import java.util.*;
import java.util.stream.IntStream;

public class Entrapment_AN {
    static final int[][] ADJ = {
        {},
        {2, 4},
        {1, 3, 5},
        {2, 6},
        {1, 5, 7},
        {2, 4, 6, 8},
        {3, 5, 9},
        {4, 8},
        {5, 7, 9},
        {6, 8}
    };
    static final int[] MOVE = new int[10];
    static {
        for (int i = 0; i < 10; i++) {
            for (int x : ADJ[i]) MOVE[i] |= 1 << x;
        }
    }
    static final int move(int pos, int avail) {
        int dest = 0;
        for (int i = 1; i < 10; i++) {
            if ((pos & (1 << i)) > 0) dest |= MOVE[i];
        }
        return dest & avail;
    }

    static int[][] bestQuery = new int[1024][1024];
    static int[][] bestSurvive = new int[1024][1024];
    static int[][] bestDel = new int[1024][1024];
    static int[][] bestDelAmount = new int[1024][1024];
    static {
        for (int[] arr : bestQuery) Arrays.fill(arr, -1);
        for (int[] arr : bestSurvive) Arrays.fill(arr, -1);
        for (int[] arr : bestDel) Arrays.fill(arr, -1);
        for (int[] arr : bestDelAmount) Arrays.fill(arr, -1);
    }

    static int optimize(int pos, int avail) {
        if (bestSurvive[pos][avail] == -1) {
            bestSurvive[pos][avail] = 9;
            int query = Integer.lowestOneBit(pos);
            while (true) {
                int yes = query, no = pos - query;
                if (bestDelAmount[yes][avail] == -1) {
                    bestDelAmount[yes][avail] = 9;
                    for (int i = 1; i < 10; i++) {
                        if ((avail & (1 << i)) == 0) continue;
                        int nextAvail = avail - (1 << i);
                        int nextPos = move(yes, nextAvail);
                        int value = nextPos == 0 ? 0 : 1 + optimize(nextPos, nextAvail);
                        if (value < bestDelAmount[yes][avail]) {
                            bestDel[yes][avail] = i;
                            bestDelAmount[yes][avail] = value;
                        }
                    }
                }
                if (bestDelAmount[no][avail] == -1) {
                    bestDelAmount[no][avail] = 9;
                    for (int i = 1; i < 10; i++) {
                        if ((avail & (1 << i)) == 0) continue;
                        int nextAvail = avail - (1 << i);
                        int nextPos = move(no, nextAvail);
                        int value = nextPos == 0 ? 0 : 1 + optimize(nextPos, nextAvail);
                        if (value < bestDelAmount[no][avail]) {
                            bestDel[no][avail] = i;
                            bestDelAmount[no][avail] = value;
                        }
                    }
                }

                int answer = Math.max(bestDelAmount[yes][avail], bestDelAmount[no][avail]);
                if (answer < bestSurvive[pos][avail]) {
                    bestQuery[pos][avail] = query;
                    bestSurvive[pos][avail] = answer;
                }

                query = ((query | ~pos) + 1) & pos;
                if (query == 0) break;
            }
        }
        return bestSurvive[pos][avail];
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int r = s.nextInt(), u = s.nextInt();
        int start = 1022;
        for (int i = 0; i < u; i++) start -= (1 << s.nextInt());
        int survive = optimize(start, start);
        int pos = start, avail = start;
        if (survive < r) {
            System.out.println("Trapper");
            while (true) {
                int query = bestQuery[pos][avail];
                System.out.println(Integer.bitCount(query));
                boolean first = true;
                for (int i = 1; i < 10; i++) {
                    if ((query & (1 << i)) > 0) {
                        if (first) {
                            first = false;
                        } else {
                            System.out.print(" ");
                        }
                        System.out.print(i);
                    }
                }
                System.out.println();
                boolean response = s.next().equals("Yes");
                int revealed = response ? query : pos - query;
                System.out.println(bestDel[revealed][avail]);
                avail -= 1 << bestDel[revealed][avail];
                pos = move(revealed, avail);
                if (s.next().equals("Trapped")) break;
                if (pos == 0) {
                    // Should not be reached, since the other player should
                    // have said "Trapped"
                    System.exit(-1);
                }
            }
        } else {
            System.out.println("Runner");
            int[] hist = new int[r + 1];
            for (int turn = 0; turn < r; turn++) {
                int len = s.nextInt();
                int query = 0;
                for (int i = 0; i < len; i++) query |= 1 << s.nextInt();
                int yes = pos & query;
                int no = pos & ~query;
                int reveal;
                if (bestDelAmount[yes][avail] > bestDelAmount[no][avail]) {
                    System.out.println("Yes");
                    reveal = yes;
                } else {
                    System.out.println("No");
                    reveal = no;
                }
                hist[turn] = reveal;
                avail -= 1 << s.nextInt();
                pos = move(reveal, avail);
                if (pos == 0) {
                    // Should not be reached, we should not have trapped ourselves
                    System.exit(-1);
                } else {
                    System.out.println("Free");
                }
            }
            hist[r] = pos;
            int[] seq = new int[r + 1];
            seq[r] = 31 - Integer.numberOfLeadingZeros(Integer.lowestOneBit(hist[r]));
            for (int i = r - 1; i >= 0; i--) {
                seq[i] = 31 - Integer.numberOfLeadingZeros(Integer.lowestOneBit(hist[i] & MOVE[seq[i + 1]]));
            }
            for (int i = 0; i < r; i++) {
                System.out.print(seq[i] + " ");
            }
            System.out.println(seq[r]);
        }
    }
}
