
#include <iostream>
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#define rep(i,a,b) for(int i = a; i <(b);++i)
#define sz(x) (int)(x).size()
#define pb push_back
#define F first
#define S second
#define all(x) begin(x), end(x)

using ll = int;


using namespace std;

typedef pair<ll, ll> pii;
typedef vector<ll> vi;

int gridmask = (1<<9)-1;
int oppMove[513];

pii getPos(ll ind) {
    return {ind/3,ind%3};
}
ll getInd(pii pos) {
    return pos.first*3+pos.second;
}
int dx[] = {1,0,-1,0};
int dy[] = {0,1,0,-1};
ll getNext(int ind, int d) {
    pii cur = getPos(ind);
    pii next = {cur.F+dx[d],cur.S+dy[d]};
    if (next.F < 0 || next.F >= 3 || next.S < 0 || next.S >= 3) return -1;
    return getInd(next);
}

void precomputeOpp() {
    rep(mask,0,(1<<9)) {
        int newmask = 0;
        rep(i,0,9) {
            if (((mask>>i)&1) == 1) {
                rep(d,0,4) {
                    ll next = getNext(i,d);
                    if (next != -1) newmask = newmask|(1<<next);
                }
            }
        }
        oppMove[mask] = newmask;
    }
}

void printGrid(int mask) {
    rep(i,0,9) {
        if (((mask>>i)&1) == 1) {
            cout<<'x';
        }else {
            cout<<'.';
        }
        if (i%3 == 2) {
            cout<<'\n';
        }
    }
    cout<<endl;
}

ll invertMask(ll querymask, ll oppmask) {
    return (~querymask)&oppmask;
}
ll makeKey(ll a, ll b) {
    return (a<<9)+b;
}
ll dp(ll wallmask, ll oppmask, vi& dparr) {
    ll key = makeKey(wallmask,oppmask);
    if (dparr[key] != -1) {
        return dparr[key];
    }
    return 10000;
}


void solve() {
    int r,u; cin>>r>>u;
    int startState = 0;
    if (u > 0) {
        rep(i,0,u) {
            int v; cin>>v; v--;
            startState += (1<<v);
        }
    }
    // printGrid(startState);
    int oppMask = invertMask(startState,gridmask);
    precomputeOpp();

    vi dparr(262145,-1);
    vector<vi> bitcountToMask(10);
    rep(i,0,1<<9) {
        if ((i&startState) != startState) continue;;
        ll bc = __builtin_popcount(i);
        bitcountToMask[bc].push_back(i);
    }
    for (int i = bitcountToMask.size()-1; i >= 0; i--) {
        // cout<<"NEW MASK: "<<i<<endl;
        int counter = 0;
        for (int wallmask : bitcountToMask[i]) {
            counter++;
            int invWall = invertMask(wallmask,gridmask);
            // oppmask must be subset of inverted wallmask
            for (int oppmask = invWall; oppmask; oppmask=(oppmask-1)&invWall) {
                // if (wallmask == 384 && oppMask == )
                ll key = makeKey(wallmask,oppmask);
                ll best = 100000;
                for (int s=oppmask; s; s=(s-1)&oppmask) {
                    // s is a submask of the oppmask - query
                    ll yesmin = 10000;
                    ll nomin = 10000;
                    rep(i,0,9) {
                        // no wall if alr wall
                        if (((wallmask>>i)&1) == 1) continue;
                        ll newWallMask = wallmask|(1<<i);
                        ll opp_mask_if_yes = oppMove[s]&(~newWallMask);
                        ll opp_mask_if_no = oppMove[invertMask(s,oppmask)]&(~newWallMask);
                        yesmin = opp_mask_if_yes == 0 ? 1 : min(yesmin,1+dp(wallmask|(1<<i),opp_mask_if_yes,dparr));
                        nomin = opp_mask_if_no == 0 ? 1 : min(nomin,1+dp(wallmask|(1<<i),opp_mask_if_no,dparr));
                    }
                    best = min(best,max(yesmin,nomin));
                }
                dparr[key] = best;
            }
        }
    }
    ll key = makeKey(startState,oppMask);
    if (dparr[key] <= r) {
        cout<<"Trapper"<<endl;
        ll curState = startState;
        ll curoppmask = invertMask(curState,gridmask);
        ll round = r;
        while (true) {
            // oppmask must be subset of inverted wallmask
            // possible qs
            ll move = 0;
            for (int s=curoppmask; s; s=(s-1)&curoppmask) {
                // s is a submask of the oppmask - query
                ll yesmin = 10000;
                ll nomin = 10000;
                rep(i,0,9) {
                    // no wall if alr wall
                    if (((curState>>i)&1) == 1) continue;
                    ll newWallMask = curState|(1<<i);
                    ll opp_mask_if_yes = oppMove[s]&(~newWallMask);
                    ll opp_mask_if_no = oppMove[invertMask(s,curoppmask)]&(~newWallMask);
                    yesmin = opp_mask_if_yes == 0 ? 1 : min(yesmin,1+dp(curState|(1<<i),opp_mask_if_yes,dparr));
                    nomin = opp_mask_if_no == 0 ? 1 : min(nomin,1+dp(curState|(1<<i),opp_mask_if_no,dparr));
                }
                if (max(yesmin,nomin) <= round) {
                    move = s;
                }
            }
            cout<<__builtin_popcount(move)<<endl;
            for (int i = 0; i < 9; i++) {
                if (((move>>i)&1) == 1) {
                    cout<<i+1<<" ";
                }
            }
            cout<<endl;
            string resp; cin>>resp;
            if (resp == "Yes") {
                curoppmask = move;
            }else {
                curoppmask = curoppmask&(~move);
            }
            ll blockmove = 0;
            rep(i,0,9) {
                // no wall if alr wall
                if (((curState>>i)&1) == 1) continue;
                ll newWallMask = curState|(1<<i);
                ll opp_mask_if_yes = oppMove[curoppmask]&(~newWallMask);
                ll val = opp_mask_if_yes == 0 ? 1 : 1+dp(curState|(1<<i),opp_mask_if_yes,dparr);
                if (val <= round) {
                    blockmove = i;
                }
            }
            cout<<blockmove+1<<endl;
            curState = curState|(1<<blockmove);
            curoppmask = oppMove[curoppmask]&(~curState);
            cin>>resp;
            round--;
            if (resp == "Trapped") break;
        }

    }else {
        cout<<"Runner"<<endl;
        ll curState = startState;
        ll curoppmask = invertMask(curState,gridmask);
        ll round = r;
        vi masks;
        while (true) {
            ll s = 0;
            int numq; cin>>numq;
            rep(i,0,numq) {
                int qv; cin>>qv;
                qv--;
                s += (1<<qv);
            }
            ll yesmin = 10000;
            ll nomin = 10000;

            rep(i,0,9) {
                // no wall if alr wall
                if (((curState>>i)&1) == 1) continue;
                ll newWallMask = curState|(1<<i);
                ll opp_mask_if_yes = oppMove[s]&(~newWallMask);
                ll opp_mask_if_no = oppMove[invertMask(s,curoppmask)]&(~newWallMask);
                yesmin = opp_mask_if_yes == 0 ? 1 : min(yesmin,1+dp(curState|(1<<i),opp_mask_if_yes,dparr));
                nomin = opp_mask_if_no == 0 ? 1 : min(nomin,1+dp(curState|(1<<i),opp_mask_if_no,dparr));
            }
            if (nomin > yesmin) {
                cout<<"No"<<endl;
                curoppmask = invertMask(s,curoppmask)&(~curState);
            }else {
                cout<<"Yes"<<endl;
                curoppmask = s&(~curState);
            }
            masks.push_back(curoppmask);
            int blockmove; cin>>blockmove; blockmove--;
            curState = curState|(1<<blockmove);
            curoppmask = oppMove[curoppmask]&(~curState);
            cout<<"Free"<<endl;
            if (--round == 0) break;
        }
        masks.push_back(curoppmask);
        // printGrid(curoppmask);
        vi goodpos;
        rep(j,0,9) {
            if (((curoppmask>>j)&1) == 1) {
                goodpos.push_back(j);
                break;
            }
        }
        reverse(masks.begin(),masks.end());
        rep(j,1,masks.size()) {
            // printGrid(masks[j]);
            rep(d,0,4) {
                ll a = getNext(goodpos[j-1],d);
                if (a == -1) continue;
                if (((masks[j]>>a)&1) == 1){
                    goodpos.push_back(a);
                    break;
                }
            }
        }
        reverse(goodpos.begin(),goodpos.end());
        rep(i,0,goodpos.size()) {
            cout<<goodpos[i]+1<<" ";
        }
        cout<<endl;

    }

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--)
        solve();

    return 0;
}
